<?xml version="1.0" encoding="UTF-8"?>
<out:stylesheet exclude-result-prefixes="fm" version="1.0" xmlns:fm="http://www.hyfinity.com/formmaker" xmlns:out="http://www.w3.org/1999/XSL/Transform">
<!--Some information has been retained from the existing file!-->
	<out:import href="demo_skin.xsl" />
	<out:output encoding="UTF-8" indent="yes" method="xml" />
	<out:template name="section_title">NewForm</out:template>
	<out:template name="page_meta_tags">
<!--Insert any required page specific meta tags in here-->
	</out:template>
	<out:template name="css_imports">
		<link href="css/demo.css" rel="stylesheet" type="text/css" xmlns="" />
	</out:template>
	<out:template name="page_scripts" />
	<out:template name="section_body">
<xform:xform xmlns:xform="http://www.w3.org/2001/08/xforms" xmlns="" xmlns:fm="http://www.hyfinity.com/formmaker" xmlns:mvc="http://www.hyfinity.com/mvc" xmlns:ns1="http://www.bookstore.co.uk/account/orders" >		<div class="form" xmlns="">
			<form action="process.do" method="post" name="Useful_XPath_Queries">
				<out:if test="/mvc:eForm/mvc:Control/mvc:Language != ''">
					<input name="Language" type="hidden" value="{/mvc:eForm/mvc:Control/mvc:Language}" />
				</out:if>
				<input name="is_script_enabled" type="hidden" value="false" />
				<script type="text/javascript">
					<out:text>document.Useful_XPath_Queries</out:text>
					<out:text>.is_script_enabled.value = 'true';</out:text>
				</script>
				<div class="groupLabelBackground" id="form_fields_container_label_container">
					<h2 class="label" id="form_fields_container_label">Form Contents</h2>
				</div>
				<div class="borderedGroup vertical" id="form_fields_container">
					<fieldset class="fieldsetGroup vertical" id="search_fields_group" style="width:70%;">
						<legend class="fieldsetGroupLabelBackground" id="search_fields_group_label_container">
							<span class="label" id="search_fields_group_label">Search Fields</span>
						</legend>
						<table border="0" cellpadding="0" cellspacing="0" class="stretchedGroup vertical force" id="layout_group_2" summary="">
							<tr>
								<td class="labelBackground" id="searchFor_label_container" style="width:60%;">
									<label class="label" for="searchFor" id="searchFor_label">Search Orders for:</label>
								</td>
								<td class="defaultBackground" id="searchFor_container" style="width:40%;">
									<input class="textbox" id="searchFor" name="searchFor" type="text" value="{/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor}" />
									<span id="searchFor_message_container"></span>
								</td>
							</tr>
							<tr>
								<td class="labelBackground" id="selectedBookNumber_label_container">
									<label class="label" for="selectedBookNumber" id="selectedBookNumber_label">Selected Row for Multiple Rows of Data</label>
								</td>
								<td class="defaultBackground" id="selectedBookNumber_container">
									<input class="textbox" id="selectedBookNumber" name="selectedBookNumber" type="text" value="{/mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber}" />
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
				<div class="groupLabelBackground" id="xpath_query_results_label_container">
					<h2 class="label" id="xpath_query_results_label">XPath Query Results</h2>
				</div>
				<table border="0" cellpadding="0" cellspacing="0" class="borderedGroup vertical force" id="xpath_query_results" style="width:100%;" summary="">
					<tr>
						<td colspan="2">
							<fieldset class="fieldsetGroup vertical" id="select_queries_group" style="width:70%;">
								<legend class="fieldsetGroupLabelBackground" id="select_queries_group_label_container">
									<span class="label" id="select_queries_group_label">Select Queries</span>
								</legend>
								<table border="0" cellpadding="0" cellspacing="0" class="stretchedGroup vertical force" id="Select_Query_Questions" summary="">
									<tr>
										<td class="labelBackground" id="Query_1_1_label_container" style="width:60%;">
											<label class="label" for="Query_1_1" id="Query_1_1_label">Query 1.1 - Select the search field from the form fields</label>
										</td>
										<td class="defaultBackground" id="Query_1_1_container" style="width:40%;">
											<span class="output" id="Query_1_1">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor) or (/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_2_label_container">
											<label class="label" for="Query_1_2" id="Query_1_2_label">Query 1.2 - Select the title of the second book</label>
										</td>
										<td class="defaultBackground" id="Query_1_2_container">
											<span class="output" id="Query_1_2">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:title) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:title = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:title" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_3_label_container">
											<label class="label" for="Query_1_3" id="Query_1_3_label">Query 1.3 - Select the title of the book based on an index value provided</label>
										</td>
										<td class="defaultBackground" id="Query_1_3_container">
											<span class="output" id="Query_1_3">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[position() = /mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber]/ns1:title) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book[position() = /mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber]/ns1:title = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book[position() = /mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber]/ns1:title" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_4_label_container" style="width:60%;">
											<label class="label" for="Query_1_4" id="Query_1_4_label">Query 1.4 - Select the year of the first book in the WEB category</label>
										</td>
										<td class="defaultBackground" id="Query_1_4_container" style="width:40%;">
											<span class="output" id="Query_1_4">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[@category = 'WEB']/ns1:year) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book[@category = 'WEB']/ns1:year = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book[@category = 'WEB']/ns1:year" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_5_label_container">
											<label class="label" for="Query_1_5" id="Query_1_5_label">Query 1.5 - Select the category name description of all the book categories that have orders </label>
										</td>
										<td class="defaultBackground" id="Query_1_5_container">
											<span class="output" id="Query_1_5">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/categories/category[@type = /mvc:eForm/mvc:Data/ns1:orders/ns1:book/@category]) or (/mvc:eForm/mvc:Data/categories/category[@type = /mvc:eForm/mvc:Data/ns1:orders/ns1:book/@category] = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/categories/category[@type = /mvc:eForm/mvc:Data/ns1:orders/ns1:book/@category]" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_6_label_container">
											<label class="label" for="Query_1_6" id="Query_1_6_label">Query 1.6 - Select the title of the first book by an author called Erik</label>
										</td>
										<td class="defaultBackground" id="Query_1_6_container">
											<span class="output" id="Query_1_6">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author, &quot;Erik&quot;)]/ns1:title
) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author, &quot;Erik&quot;)]/ns1:title
 = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author, &quot;Erik&quot;)]/ns1:title
" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_1_7_label_container">
											<label class="label" for="Query_1_7" id="Query_1_7_label">Query 1.7 - Select the title of books by an author searched for, that are in english</label>
										</td>
										<td class="defaultBackground" id="Query_1_7_container">
											<span class="output" id="Query_1_7">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author,/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor) and ns1:title/@lang = &quot;en&quot;]/ns1:title) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author,/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor) and ns1:title/@lang = &quot;en&quot;]/ns1:title = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book[contains(ns1:author,/mvc:eForm/mvc:Data/mvc:formData/mvc:searchFor) and ns1:title/@lang = &quot;en&quot;]/ns1:title" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
								</table>
							</fieldset>
						</td>
					</tr>
					<tr>
						<td colspan="2">
							<fieldset class="fieldsetGroup vertical" id="checking_group" style="width:70%;">
								<legend class="fieldsetGroupLabelBackground" id="checking_group_label_container">
									<span class="label" id="checking_group_label">Checking Queries</span>
								</legend>
								<table border="0" cellpadding="0" cellspacing="0" class="stretchedGroup vertical force" id="Check_Queries_Questions" summary="">
									<tr>
										<td class="labelBackground" id="Query_2_1_label_container" style="width:60%;">
											<label class="label" for="Query_2_1" id="Query_2_1_label">Query 2.1 - Check if the selectedBookNumber field has a value</label>
										</td>
										<td class="defaultBackground" id="Query_2_1_container" style="width:40%;">
											<span class="output" id="Query_2_1">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber[. != '']) or (/mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber[. != ''] = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/mvc:formData/mvc:selectedBookNumber[. != '']" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_2_2_label_container">
											<label class="label" for="Query_2_2" id="Query_2_2_label">Query 2.2 - Check if the fourth category does not have a category type defined</label>
										</td>
										<td class="defaultBackground" id="Query_2_2_container">
											<span class="output" id="Query_2_2">
												<out:choose>
													<out:when test="not(not(/mvc:eForm/mvc:Data/categories/category[4]/@type[. != ''])) or (not(/mvc:eForm/mvc:Data/categories/category[4]/@type[. != '']) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="not(/mvc:eForm/mvc:Data/categories/category[4]/@type[. != ''])" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_2_3_label_container">
											<label class="label" for="Query_2_3" id="Query_2_3_label">Query 2.3 - Select the first book orders price with book prices over 35</label>
										</td>
										<td class="defaultBackground" id="Query_2_3_container">
											<span class="output" id="Query_2_3">
												<out:choose>
													<out:when test="not(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price[. &gt; '35.00']) or (/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price[. &gt; '35.00'] = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price[. &gt; '35.00']" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
								</table>
							</fieldset>
						</td>
					</tr>
					<tr>
						<td colspan="2">
							<fieldset class="fieldsetGroup vertical" id="functions_group" style="width:70%;">
								<legend class="fieldsetGroupLabelBackground" id="functions_group_label_container">
									<span class="label" id="functions_group_label">Functions to manipulate values</span>
								</legend>
								<table border="0" cellpadding="0" cellspacing="0" class="stretchedGroup vertical force" id="Function_Questions" summary="">
									<tr>
										<td class="labelBackground" id="Query_3_1_label_container" style="width:60%;">
											<label class="label" for="Query_3_1" id="Query_3_1_label">Query 3.1 - Select the author of the book and join with the title placed in quotes </label>
										</td>
										<td class="defaultBackground" id="Query_3_1_container" style="width:40%;">
											<span class="output" id="Query_3_1">
												<out:choose>
													<out:when test="not(concat(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:author, ' wrote &quot;', /mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:title, '&quot;')) or (concat(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:author, ' wrote &quot;', /mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:title, '&quot;') = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="concat(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:author, ' wrote &quot;', /mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:title, '&quot;')" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground " id="Query_3_2_label_container">
											<label class="label" for="Query_3_2" id="Query_3_2_label">Query 3.2 - Shorten the year value of the first book by removing the century</label>
										</td>
										<td class="defaultBackground" id="Query_3_2_container">
											<span class="output" id="Query_3_2">
												<out:choose>
													<out:when test="not(substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[1]/ns1:year,3,2)) or (substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[1]/ns1:year,3,2) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[1]/ns1:year,3,2)" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_3_label_container">
											<label class="label" for="Query_3_3" id="Query_3_3_label">Query 3.3 - Merge ‘**’ fields with the last two digits of the first books year </label>
										</td>
										<td class="defaultBackground" id="Query_3_3_container">
											<span class="output" id="Query_3_3">
												<out:choose>
													<out:when test="not(concat('**',substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:year,3,2))) or (concat('**',substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:year,3,2)) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="concat('**',substring(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:year,3,2))" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_4_label_container">
											<label class="label" for="Query_3_4" id="Query_3_4_label">Query 3.4 - Round the price of book 2</label>
										</td>
										<td class="defaultBackground" id="Query_3_4_container">
											<span class="output" id="Query_3_4">
												<out:choose>
													<out:when test="not(round(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:price)) or (round(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:price) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="round(/mvc:eForm/mvc:Data/ns1:orders/ns1:book[2]/ns1:price)" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_5_label_container">
											<label class="label" for="Query_3_5" id="Query_3_5_label">Query 3.5 - Count how many books ordered</label>
										</td>
										<td class="defaultBackground" id="Query_3_5_container">
											<span class="output" id="Query_3_5">
												<out:choose>
													<out:when test="not(count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book)) or (count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book)" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_6_label_container">
											<label class="label" for="Query_3_6" id="Query_3_6_label">Query 3.6 - Sum all the prices of the books ordered</label>
										</td>
										<td class="defaultBackground" id="Query_3_6_container">
											<span class="output" id="Query_3_6">
												<out:choose>
													<out:when test="not(sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price)) or (sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price)" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_7_label_container">
											<label class="label" for="Query_3_7" id="Query_3_7_label">Query 3.7 - Average value of books ordered </label>
										</td>
										<td class="defaultBackground" id="Query_3_7_container">
											<span class="output" id="Query_3_7">
												<out:choose>
													<out:when test="not(sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price) div count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price)) or (sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price) div count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price) = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="sum(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price) div count(/mvc:eForm/mvc:Data/ns1:orders/ns1:book/ns1:price)" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
									<tr>
										<td class="labelBackground" id="Query_3_8_label_container">
											<label class="label" for="Query_3_8" id="Query_3_8_label">Query 3.8 - Always perform</label>
										</td>
										<td class="defaultBackground" id="Query_3_8_container">
											<span class="output" id="Query_3_8">
												<out:choose>
													<out:when test="not(true()) or (true() = '')">
														<out:text disable-output-escaping="yes">&amp;#160;</out:text>
													</out:when>
													<out:otherwise>
														<out:value-of select="true()" />
													</out:otherwise>
												</out:choose>
											</span>
										</td>
									</tr>
								</table>
							</fieldset>
						</td>
					</tr>
				</table>
			</form>
		</div>
</xform:xform>		<script type="text/javascript" xmlns="">
			<out:text disable-output-escaping="yes">

            /*
             * Do NOT edit or add to the following script.
             * It will be recreated each time the page is regenerated!
             * Instead use the Application Map screen to add an external
             * script file to your page, and place your code in there.
             */

            hyf.validation.config =
            {
                form: document.Useful_XPath_Queries,
                errorDisplayMethod: 'tooltip',
                errorDisplayMessageClass: 'errorIcon',
                errorDisplayShowMessage: true,
                errorDisplayShowAlerts: false,
                errorDisplayValidationMode: 'all'
            }
        			</out:text>
<xsl:for-each select="." xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fm="http://www.hyfinity.com/formmaker" xmlns:mvc="http://www.hyfinity.com/mvc" xmlns:ns1="http://www.bookstore.co.uk/account/orders"><xsl:text disable-output-escaping="yes" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"></xsl:text>			<out:text>
            field = document.getElementById('</out:text>
			<out:text>searchFor</out:text>
			<out:text>');</out:text>
			<out:text disable-output-escaping="yes">field.setAttribute('_required','false');</out:text>
			<out:text disable-output-escaping="yes">field.setAttribute('_type','string');</out:text>
			<out:text>
            field = document.getElementById('</out:text>
			<out:text>selectedBookNumber</out:text>
			<out:text>');</out:text>
			<out:text disable-output-escaping="yes">field.setAttribute('_required','false');</out:text>
			<out:text disable-output-escaping="yes">field.setAttribute('_type','string');</out:text>
			<out:text disable-output-escaping="yes">field.setAttribute('_validate', 'false');</out:text>
</xsl:for-each>		</script>
	</out:template>
</out:stylesheet>
